﻿using System.Collections.Generic;
using WcfService1dto;
using WcfService1.webserviceclient;

namespace WcfService1
{
    public class WCFAnagraficaService : IWCFAnagraficaService
    {
        
        //approccio thread safe
        private static readonly object _synch = new object();
        private static volatile WebServiceSoapClient<IAnagraficaInterface> webServiceClient;
          
         
        public DatiPersonaDto GetDatiAnagrafici(string username)
        {
            
            var result1 = this.Channel.getPersona(username);
            DatiPersonaDto dto =  new DatiPersonaDto();
            
            dto.UserId = result1.UserId;
            dto.Cognome = result1.Cognome;
            dto.Nome = result1.Nome;
            dto.DataNascita = result1.DataNascita;
            IndirizzoDto indirizzoDto = new IndirizzoDto();
            indirizzoDto.IdIndirizzo = 1;
            indirizzoDto.TipoIndirizzo = "residenza";
            indirizzoDto.CAP = result1.CAPResidenza;
            indirizzoDto.Citta = result1.CittaResidenza;
            indirizzoDto.Indirizzo = result1.IndirizzoResidenza;
            indirizzoDto.Provincia = result1.ProvinciaResidenza;
            IndirizzoDto[] indirizzi = new IndirizzoDto[1];
            indirizzi[0] = indirizzoDto;
            dto.Indirizzi = indirizzi; 
            return dto;
        }



        public List<DatiMovimentoDto> GetMovimentiPersona(string username)
        { 
            int userid = 1;
            if (username.Equals("test"))
            {
                userid = 2;
            }

            var res = this.Channel.getMovimenti(userid);

            List<DatiMovimentoDto> listaMovimenti = new List<DatiMovimentoDto>();
            foreach (MovimentoDTO item in res)
            {
                DatiMovimentoDto dto = new DatiMovimentoDto();
                dto.DataMovimento = item.DataMovimento;
                dto.Descrizione = item.Descrizione;
                dto.Valore = item.Valore;

                listaMovimenti.Add(dto);
                
            }

            return listaMovimenti;
        }
         


        public IAnagraficaInterface Channel
        {
            get
            {
                if (webServiceClient == null)
                {
                    lock (_synch)
                    {
                        if (webServiceClient == null)
                        {
                            webServiceClient = new WebServiceSoapClient<IAnagraficaInterface>(
                                                    @"http://localhost:4715/Service1.asmx");
                        }
                    }
                }
                return webServiceClient.Channel;
            }
        }
  

    }
}
